﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Configuration;
using System.Data.SqlClient;
using System.Data;
using System.Text;
using System.Web.Script.Serialization;

namespace TestWeb
{
    public partial class WebForm1 : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!Page.IsPostBack)
            {
                LoadData();
            }
        }

        private void LoadData()
        {
            string consString = ConfigurationManager.ConnectionStrings["TEST"].ConnectionString;
            using (SqlConnection conn = new SqlConnection(consString))
            {
                SqlCommand cmd = new SqlCommand("SELECT * FROM [tblStudent]", conn);
                cmd.CommandType = CommandType.Text;
                conn.Open();
                SqlDataReader drStudents = cmd.ExecuteReader();
                GridView1.DataSource = drStudents;
                GridView1.DataBind();
            }
        }

        protected void OnCheckedChanged(object sender, EventArgs e)
        {
            bool isUpdateVisible = false;
            lblMessage.Text = string.Empty;

            foreach (GridViewRow row in GridView1.Rows)
            {
                if (row.RowType == DataControlRowType.DataRow)
                {
                    bool isChecked = row.Cells[0].Controls.OfType<CheckBox>().FirstOrDefault().Checked;
                    if (isChecked)
                        row.RowState = DataControlRowState.Edit;

                    for (int i = 3; i < row.Cells.Count; i++)
                    {
                        row.Cells[i].Controls.OfType<Label>().FirstOrDefault().Visible = !isChecked;
                        if (row.Cells[i].Controls.OfType<TextBox>().ToList().Count > 0)
                        {
                            row.Cells[i].Controls.OfType<TextBox>().FirstOrDefault().Visible = isChecked;
                        }

                        if (isChecked && !isUpdateVisible)
                        {
                            isUpdateVisible = true;
                        }
                    }
                }
            }
            btnUpdate.Visible = isUpdateVisible;
        }

        protected void btnUpdate_Click(object sender, EventArgs e)
        {
            try
            {
                //StringBuilder sb = new StringBuilder();
                //sb.Append("[");
                List<Student> students = new List<Student>();

                foreach (GridViewRow row in GridView1.Rows)
                {
                    bool isChecked = row.Cells[0].Controls.OfType<CheckBox>().FirstOrDefault().Checked;
                    if (isChecked)
                    {
                        TextBox txtC = (TextBox)row.FindControl("txtC");
                        TextBox txtCPP = (TextBox)row.FindControl("txtCPP");
                        TextBox txtCS = (TextBox)row.FindControl("txtCS");

                        students.Add(new Student()
                        {
                            ID = row.Cells[1].Text,
                            C = txtC.Text,
                            CPP = txtCPP.Text,
                            CS = txtCS.Text
                        });

                        //sb.Append("{");
                        //sb.AppendFormat("\"ID\":\"{0}\",\"C\":\"{1}\",\"CPP\":\"{2}\",\"CS\":\"{3}\"", 
                        //row.Cells[1].Text, txtC.Text, txtCPP.Text, txtCS.Text);
                        //sb.Append("},");
                    }
                }

                //if (sb.ToString().Length > 1)
                if (students.Count > 0)
                {
                    //sb.Append("]");
                    //string inputData = sb.ToString();
                    JavaScriptSerializer serializer = new JavaScriptSerializer();
                    string inputData = serializer.Serialize(students);

                    string consString = ConfigurationManager.ConnectionStrings["TEST"].ConnectionString;
                    using (SqlConnection conn = new SqlConnection(consString))
                    {
                        SqlCommand cmd = new SqlCommand("spUpdateMarks", conn);
                        cmd.CommandType = CommandType.StoredProcedure;
                        cmd.Parameters.AddWithValue("@inputJSON", inputData);
                        conn.Open();
                        cmd.ExecuteNonQuery();
                    }
                    btnUpdate.Visible = false;
                    lblMessage.Text = "Data updated successfully!";
                    LoadData();
                }
                else
                {
                    lblMessage.Text = "No value selected for update!";
                }
            }
            catch (SqlException ex)
            {
                lblMessage.Text = "error" + ex.ToString();
            }
        }
    }

    public class Student
    {
        public string ID { get; set; }
        public string C { get; set; }
        public string CPP { get; set; }
        public string CS { get; set; }
    }
}